## libime 0.0~git20191230.5b6e890%2Bds2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
set(LibIME_VERSION 0.0.1)
project(libime VERSION ${LibIME_VERSION})

find_package(ECM 1.0 REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

#########################################
# Options
#########################################
option(ENABLE_TEST "Build Test" On)
option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
option(ENABLE_DOC "Build doxygen" Off)

#########################################
# Dependency
#########################################

include(GNUInstallDirs)
include(FeatureSummary)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGeneratePkgConfigFile)
include(ECMUninstallTarget)

find_package(Fcitx5Utils REQUIRED)
include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

find_package(Boost 1.61 REQUIRED)
set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)

    if (ENABLE_COVERAGE)
        add_custom_target(coverage
                        COMMAND "${CMAKE_CTEST_COMMAND}"
                        COMMAND lcov --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                        COMMAND lcov --remove coverage.info "*/kenlm/*" -o coverage.info
                        COMMAND genhtml coverage.info --output-directory "coverage_pages"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
endif()

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LIBIME_SINGLE_FILE_TEST
    testtable
    testpinyindata
    testpinyinencoder
    testinputbuffer
    testhistorybigram
    testshuangpinprofile
    testtrie
    testautophrasedict
    )

foreach(TESTCASE ${LIBIME_SINGLE_FILE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} LibIME::Core LibIME::Pinyin LibIME::Table )
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

add_executable(testmodel testmodel.cpp)
target_link_libraries(testmodel LibIME::Core)

add_executable(testprediction testprediction.cpp)
target_link_libraries(testprediction LibIME::Core)

add_executable(testpinyinime testpinyinime.cpp)
target_link_libraries(testpinyinime LibIME::Pinyin)

add_executable(testpinyindictionary testpinyindictionary.cpp)
target_link_libraries(testpinyindictionary LibIME::Pinyin)
add_executable(testpinyincontext testpinyincontext.cpp)
target_link_libraries(testpinyincontext LibIME::Pinyin)

add_executable(triebench triebench.cpp)
target_link_libraries(triebench LibIME::Core)
add_executable(testdecoder testdecoder.cpp)
target_link_libraries(testdecoder LibIME::Pinyin)

add_executable(testtableime testtableime.cpp)
target_link_libraries(testtableime LibIME::Table)

=== src/libime/table/CMakeLists.txt ===
set(LIBIME_TABLE_HDRS
    tablebaseddictionary.h
    tablecontext.h
    tableoptions.h
    tablerule.h
    tabledecoder.h
    autophrasedict.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimetable_export.h
    )

set(LIBIME_TABLE_SRCS
    tablebaseddictionary.cpp
    tablecontext.cpp
    tableoptions.cpp
    tabledecoder.cpp
    autophrasedict.cpp
    log.cpp
    )

add_library(IMETable SHARED ${LIBIME_TABLE_SRCS})
set_target_properties(IMETable
                      PROPERTIES VERSION 0.1
                      SOVERSION 0
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
                      EXPORT_NAME Table
)
target_include_directories(IMETable PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)

install(TARGETS IMETable EXPORT LibIMETableTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_TABLE_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/table")

add_library(LibIME::Table ALIAS IMETable)

ecm_setup_version(PROJECT
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake"
                  SOVERSION 0)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMETableConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
)

generate_export_header(IMETable BASE_NAME LibIMETable)

install(EXPORT LibIMETableTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable" FILE LibIMETableTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
        COMPONENT Devel )

=== debian/control ===
Source: libime
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7),
 debhelper-compat (= 12),
 extra-cmake-modules,
 libboost-dev (>= 1.61),
 libdouble-conversion-dev,
 libfcitx5utils-dev (>= 0.0~git20191114~),
 python3:any,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/libime
Vcs-Git: https://salsa.debian.org/input-method-team/libime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/libime

Package: libime-bin
Architecture: linux-any
Section: utils
Depends:
 libimecore0 (= ${binary:Version}),
 libimepinyin0 (= ${binary:Version}),
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (tools)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides tools provided by libime.

Package: libime-data
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 ${misc:Depends},
Description: Generic Input Method Implementation library (data files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides architecture-independent data files.

Package: libimecore-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends:
 libimecore0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (core dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for core library.

Package: libimecore0
Architecture: linux-any
Multi-Arch: same
Depends:
 libime-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (core library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its core library.

Package: libimepinyin-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends:
 libimepinyin0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (pinyin dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for pinyin library.

Package: libimepinyin0
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (pinyin library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its pinyin library.

Package: libimetable-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends:
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (table dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for table library.

Package: libimetable0
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (table library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its table library.

## libime 0.0~git20191230.5b6e890+ds2

=== data/CMakeLists.txt ===
find_package(PythonInterp 3 REQUIRED)
set(OPENGRAM_LM_TAR "lm_sc.3gm.arpa-20140820.tar.bz2")
# Use our own file server for convenience.
set(OPENGRAM_LM_URL "https://download.fcitx-im.org/data/${OPENGRAM_LM_TAR}")

fcitx5_download(opengram-lm-download ${OPENGRAM_LM_URL} ${OPENGRAM_LM_TAR}
                751bab7c55ea93a2cedfb0fbb7eb09f67d4da9c2c55496e5f31eb8580f1d1e2f)
fcitx5_extract(opengram-lm-extract ${OPENGRAM_LM_TAR} DEPENDS opengram-lm-download
               OUTPUT lm_sc.3gm.arpa)

set(OPENGRAM_LM_SRC "${CMAKE_CURRENT_BINARY_DIR}/kenlm_sc.arpa")
set(OPENGRAM_LM_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.lm")
set(OPENGRAM_LM_PREDICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.lm.predict")
add_custom_command(
  OUTPUT "${OPENGRAM_LM_SRC}"
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/lm_sc.3gm.arpa" ${CMAKE_CURRENT_SOURCE_DIR}/convert_open_gram_arpa.py
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/convert_open_gram_arpa.py "${CMAKE_CURRENT_BINARY_DIR}/lm_sc.3gm.arpa" > "${OPENGRAM_LM_SRC}")
add_custom_command(
  OUTPUT "${OPENGRAM_LM_OUTPUT}"
  DEPENDS "${OPENGRAM_LM_SRC}" LibIME::slm_build_binary
  COMMAND LibIME::slm_build_binary -s -a 22 -q 8 trie "${OPENGRAM_LM_SRC}" "${OPENGRAM_LM_OUTPUT}")
add_custom_target(opengram-lm ALL DEPENDS "${OPENGRAM_LM_OUTPUT}")

add_custom_command(
  OUTPUT "${OPENGRAM_LM_PREDICT_OUTPUT}"
  DEPENDS "${OPENGRAM_LM_SRC}" opengram-lm LibIME::prediction
  COMMAND LibIME::prediction "${OPENGRAM_LM_OUTPUT}" "${OPENGRAM_LM_SRC}" "${OPENGRAM_LM_PREDICT_OUTPUT}")
add_custom_target(opengram-lm-predict ALL DEPENDS "${OPENGRAM_LM_PREDICT_OUTPUT}")

install(FILES "${OPENGRAM_LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
install(FILES "${OPENGRAM_LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")

set(OPENGRAM_DICT_TAR "dict.utf8-20170423.tar.xz")
set(OPENGRAM_DICT_URL "https://download.fcitx-im.org/data/dict.utf8-20170423.tar.xz")

fcitx5_download(opengram-dict-download ${OPENGRAM_DICT_URL} ${OPENGRAM_DICT_TAR}
                15775a25c9b4e02891e935e0b0dc692ee6d5a747079e7239c1a71976db90f54e)
fcitx5_extract(opengram-dict-extract ${OPENGRAM_DICT_TAR} DEPENDS opengram-dict-download
               OUTPUT dict.utf8)
set(OPENGRAM_DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict.converted")
set(OPENGRAM_DICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.dict")
add_custom_command(
  OUTPUT "${OPENGRAM_DICT_SRC}"
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/dict.utf8" ${CMAKE_CURRENT_SOURCE_DIR}/convert_open_gram_dict.py
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/convert_open_gram_dict.py "${CMAKE_CURRENT_BINARY_DIR}/dict.utf8" > "${OPENGRAM_DICT_SRC}")
add_custom_command(
  OUTPUT "${OPENGRAM_DICT_OUTPUT}"
  DEPENDS "${OPENGRAM_DICT_SRC}" LibIME::pinyindict
  COMMAND LibIME::pinyindict "${OPENGRAM_DICT_SRC}" "${OPENGRAM_DICT_OUTPUT}")
add_custom_target(opengram-dict ALL DEPENDS "${OPENGRAM_DICT_OUTPUT}")
install(FILES "${OPENGRAM_DICT_OUTPUT}" DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")

set(TABLE_DICT_URL "https://download.fcitx-im.org/data/table.tar.gz")
set(TABLE_DICT_TAR "table.tar.gz")
set(TABLE_TXT_FILES db.txt erbi.txt qxm.txt wanfeng.txt
                      wbpy.txt wbx.txt zrm.txt cj.txt)
fcitx5_download(table-dict-download ${TABLE_DICT_URL} ${TABLE_DICT_TAR}
                6196053c724125e3ae3d8bd6b2f9172d0c83b65b0d410d3cde63b7a8d6ab87b7)
fcitx5_extract(table-dict-extract ${TABLE_DICT_TAR} DEPENDS table-dict-download
               OUTPUT ${TABLE_TXT_FILES})

set(TABLE_DICT_FILES)
foreach(TABLE_TXT_FILE ${TABLE_TXT_FILES})
  string(REPLACE .txt .main.dict TABLE_DICT_FILE ${TABLE_TXT_FILE})
  add_custom_command(OUTPUT ${TABLE_DICT_FILE}
                     DEPENDS ${TABLE_TXT_FILE} LibIME::tabledict
                     COMMAND LibIME::tabledict ${TABLE_TXT_FILE} ${CMAKE_CURRENT_BINARY_DIR}/${TABLE_DICT_FILE})
  list(APPEND TABLE_DICT_FILES ${CMAKE_CURRENT_BINARY_DIR}/${TABLE_DICT_FILE})
endforeach()

add_custom_target(table-dict ALL DEPENDS ${TABLE_DICT_FILES})
install(FILES ${TABLE_DICT_FILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")

=== tools/CMakeLists.txt ===
add_executable(libime_slm_build_binary ../src/libime/core/kenlm/lm/build_binary_main.cc)
target_link_libraries(libime_slm_build_binary kenlm)

install(TARGETS libime_slm_build_binary DESTINATION ${CMAKE_INSTALL_BINDIR})
add_executable(LibIME::slm_build_binary ALIAS libime_slm_build_binary)

add_executable(libime_prediction libime_prediction.cpp)
target_link_libraries(libime_prediction LibIME::Core)
install(TARGETS libime_prediction DESTINATION ${CMAKE_INSTALL_BINDIR})
add_executable(LibIME::prediction ALIAS libime_prediction)

add_executable(libime_pinyindict libime_pinyindict.cpp)
target_link_libraries(libime_pinyindict LibIME::Pinyin)
install(TARGETS libime_pinyindict DESTINATION ${CMAKE_INSTALL_BINDIR})
add_executable(LibIME::pinyindict ALIAS libime_pinyindict)

add_executable(libime_history libime_history.cpp)
target_link_libraries(libime_history LibIME::Core)
install(TARGETS libime_history DESTINATION ${CMAKE_INSTALL_BINDIR})
add_executable(LibIME::history ALIAS libime_history)

add_executable(libime_tabledict libime_tabledict.cpp)
target_link_libraries(libime_tabledict LibIME::Table)
install(TARGETS libime_tabledict DESTINATION ${CMAKE_INSTALL_BINDIR})
add_executable(LibIME::tabledict ALIAS libime_tabledict)

=== src/libime/core/CMakeLists.txt ===
# logic from setup.py
file(GLOB __KENLM_SRCS kenlm/lm/*.cc kenlm/util/*.cc kenlm/util/double-conversion/*.cc)
set(KENLM_SRCS)
foreach(f ${__KENLM_SRCS})
    string(REGEX MATCH "test\\.cc" IS_TEST ${f})
    string(REGEX MATCH "main\\.cc" IS_MAIN ${f})
    if(NOT IS_TEST AND NOT IS_MAIN)
        set(KENLM_SRCS ${KENLM_SRCS} ${f})
    endif()
endforeach()

add_library(kenlm STATIC ${KENLM_SRCS})
target_include_directories(kenlm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/kenlm>)
target_compile_definitions(kenlm PUBLIC -DKENLM_MAX_ORDER=3 PRIVATE -DNDEBUG)
target_link_libraries(kenlm PUBLIC Boost::boost)
set_target_properties(kenlm PROPERTIES
                      COMPILE_FLAGS "-fPIC")

set(LIBIME_HDRS
    datrie.h
    decoder.h
    languagemodel.h
    inputbuffer.h
    segmentgraph.h
    lattice.h
    languagemodel.h
    historybigram.h
    dictionary.h
    userlanguagemodel.h
    lrucache.h
    prediction.h
    triedictionary.h
    utils.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimecore_export.h
    )

set(LIBIME_SRCS
    datrie.cpp
    decoder.cpp
    languagemodel.cpp
    inputbuffer.cpp
    lattice.cpp
    userlanguagemodel.cpp
    historybigram.cpp
    segmentgraph.cpp
    utils.cpp
    prediction.cpp
    triedictionary.cpp
    )

add_library(IMECore SHARED ${LIBIME_SRCS})
set_target_properties(IMECore
                      PROPERTIES VERSION 0.1
                      SOVERSION 0
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
                      EXPORT_NAME Core
)
target_include_directories(IMECore PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMECore PUBLIC Fcitx5::Utils Boost::boost PRIVATE kenlm)

install(TARGETS IMECore EXPORT LibIMECoreTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/core")

add_library(LibIME::Core ALIAS IMECore)

ecm_setup_version(PROJECT
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake"
                  SOVERSION 0)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMECoreConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
)

generate_export_header(IMECore BASE_NAME LibIMECore)

install(EXPORT LibIMECoreTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore" FILE LibIMECoreTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
        COMPONENT Devel )

=== src/libime/pinyin/CMakeLists.txt ===
set(LIBIME_PINYIN_HDRS
    pinyincontext.h
    pinyindata.h
    pinyindecoder.h
    pinyindictionary.h
    pinyinencoder.h
    pinyinime.h
    pinyinmatchstate.h
    pinyinmatchstate_p.h
    shuangpindata.h
    shuangpinprofile.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimepinyin_export.h
    )

set(LIBIME_PINYIN_SRCS
    pinyincontext.cpp
    pinyindata.cpp
    pinyindecoder.cpp
    pinyindictionary.cpp
    pinyinencoder.cpp
    pinyinime.cpp
    pinyinmatchstate.cpp
    shuangpinprofile.cpp
    )

add_library(IMEPinyin SHARED ${LIBIME_PINYIN_SRCS})
set_target_properties(IMEPinyin
                      PROPERTIES VERSION 0.1
                      SOVERSION 0
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
                      EXPORT_NAME Pinyin
)
target_include_directories(IMEPinyin PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMEPinyin PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)

install(TARGETS IMEPinyin EXPORT LibIMEPinyinTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_PINYIN_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/pinyin")

add_library(LibIME::Pinyin ALIAS IMEPinyin)

ecm_setup_version(PROJECT
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake"
                  SOVERSION 0)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMEPinyinConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
)

generate_export_header(IMEPinyin BASE_NAME LibIMEPinyin)

install(EXPORT LibIMEPinyinTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin" FILE LibIMEPinyinTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
        COMPONENT Devel )

=== debian/changelog ===
libime (0.0~git20191230.5b6e890+ds2-1) unstable; urgency=medium

  * ds: Let src:libime to provide required dictionaries.
  * debian/control:
    - Drop build-dependency on fcitx5-data.
    + Bump Standards-Version to 4.5.0.
    + Mark architecture-dependent packages as linux-any.

 -- Boyuan Yang <byang@debian.org>  Wed, 05 Feb 2020 16:37:00 -0500

libime (0.0~git20191230.5b6e890+ds1-2) unstable; urgency=high

  * debian/control: Let the core library depends on libime-data
    data package. This is needed by fcitx5-chinese-addons.

 -- Boyuan Yang <byang@debian.org>  Sun, 19 Jan 2020 17:33:53 -0500

libime (0.0~git20191230.5b6e890+ds1-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jan 2020 20:14:32 -0800

libime (0.0~git20191129.48c56a4+ds1-1) unstable; urgency=high

  * New upstream snapshot.
  * Source-only upload to allow testing migration.
  * debian/control: Mark dev packages as M-A: same.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Dec 2019 20:50:22 -0800

libime (0.0~git20191103.442e091+ds2-1) unstable; urgency=medium

  * Initial release. (Closes: #945850)

 -- Boyuan Yang <byang@debian.org>  Fri, 29 Nov 2019 15:58:21 -0500

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, dversionmangle=s/\+ds\d*$//" \
 https://github.com/fcitx/libime HEAD debian

## libime 0.0~git20200823.dff3ea6

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 find_package(Fcitx5Utils REQUIRED)
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
-find_package(Boost 1.61 REQUIRED)
+find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
 set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,11 @@
 install(FILES "${OPENGRAM_LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
 install(FILES "${OPENGRAM_LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
 
-set(OPENGRAM_DICT_TAR "dict.utf8-20170423.tar.xz")
-set(OPENGRAM_DICT_URL "https://download.fcitx-im.org/data/dict.utf8-20170423.tar.xz")
+set(OPENGRAM_DICT_TAR "dict.utf8-20200715.tar.xz")
+set(OPENGRAM_DICT_URL "https://download.fcitx-im.org/data/${OPENGRAM_DICT_TAR}")
 
 fcitx5_download(opengram-dict-download ${OPENGRAM_DICT_URL} ${OPENGRAM_DICT_TAR}
-                15775a25c9b4e02891e935e0b0dc692ee6d5a747079e7239c1a71976db90f54e)
+                23c36cd4df6de17f66bf2dfc453ec6c773641a479b6020c9e787552489c9c7d2)
 fcitx5_extract(opengram-dict-extract ${OPENGRAM_DICT_TAR} DEPENDS opengram-dict-download
                OUTPUT dict.utf8)
 set(OPENGRAM_DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict.converted")

=== debian/changelog ===
libime (0.0~git20200823.dff3ea6-2) unstable; urgency=medium

  * Team upload.
  * Disable testtrie on mipsx and hppa

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 27 Aug 2020 02:38:52 +0800

libime (0.0~git20200823.dff3ea6-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * as-needed LDFLAGS is not needed since bullseye
  * Changes architecture from linux-any to any
  * Refresh patches
  * Update bundled dict.utf8
  * Tests on i386 are fixed

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 26 Aug 2020 11:56:39 +0800

libime (0.0~git20200626.2c85668-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * Bump debhelper-compat to 13 and clean up d/rules
  * Update dict.utf8 to 20200613
  * Refresh patches
  * Add libboost-iostreams-dev to Build-Depends
  * Bump libfcitx5utils-dev to 0.0~git20200626

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 02 Jul 2020 11:44:03 +0800

libime (0.0~git20200318.a78efdf-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * Ignore failing test on i386 for now
  * Bump fcitx version to 0.0~git20200323

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 24 Mar 2020 03:38:39 +0800

libime (0.0~git20200310.fdce632-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * Stop repacking upstream tarball.
    Move extra sources to debian directory.
  * Use cmake config from system libdouble-conversion-dev.
  * Bump libfcitx5utils-dev to 0.0~git20200311.

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 13 Mar 2020 00:19:32 +0800

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,12 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake (>= 3.7),
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  extra-cmake-modules,
  libboost-dev (>= 1.61),
- libdouble-conversion-dev,
- libfcitx5utils-dev (>= 0.0~git20191114~),
+ libboost-iostreams-dev (>= 1.61),
+ libdouble-conversion-dev (>= 3.1.5-5~),
+ libfcitx5utils-dev (>= 0.0~git20200626),
  python3:any,
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
@@ -19,7 +20,7 @@
 Vcs-Browser: https://salsa.debian.org/input-method-team/libime
 
 Package: libime-bin
-Architecture: linux-any
+Architecture: any
 Section: utils
 Depends:
  libimecore0 (= ${binary:Version}),
@@ -46,7 +47,7 @@
  This package provides architecture-independent data files.
 
 Package: libimecore-dev
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends:
@@ -59,7 +60,7 @@
  This package provides development files for core library.
 
 Package: libimecore0
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Depends:
  libime-data (= ${source:Version}),
@@ -72,7 +73,7 @@
  This package provides its core library.
 
 Package: libimepinyin-dev
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends:
@@ -85,7 +86,7 @@
  This package provides development files for pinyin library.
 
 Package: libimepinyin0
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
@@ -97,7 +98,7 @@
  This package provides its pinyin library.
 
 Package: libimetable-dev
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Section: libdevel
 Depends:
@@ -110,7 +111,7 @@
  This package provides development files for table library.
 
 Package: libimetable0
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

ifneq (,$(filter $(DEB_HOST_ARCH), mips64el mipsel hppa))
override_dh_auto_test:
	dh_auto_test -- ARGS+='--exclude-regex \(testtrie\)'
endif

## libime 1.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.7)
-set(LibIME_VERSION 0.0.1)
-project(libime VERSION ${LibIME_VERSION})
+project(libime VERSION 1.0.4)
+set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -10,6 +10,7 @@
 #########################################
 option(ENABLE_TEST "Build Test" On)
 option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
+set(GCOV_TOOL "gcov" CACHE STRING "Path to gcov tool used by coverage.")
 option(ENABLE_DOC "Build doxygen" Off)
 
 #########################################
@@ -28,8 +29,9 @@
 find_package(Fcitx5Utils REQUIRED)
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
-find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
+find_package(Boost 1.61 REQUIRED COMPONENTS iostreams filesystem regex)
 set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
+set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
@@ -41,7 +43,7 @@
     if (ENABLE_COVERAGE)
         add_custom_target(coverage
                         COMMAND "${CMAKE_CTEST_COMMAND}"
-                        COMMAND lcov --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
+                        COMMAND lcov --gcov-tool "${GCOV_TOOL}" --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                         COMMAND lcov --remove coverage.info "*/kenlm/*" -o coverage.info
                         COMMAND genhtml coverage.info --output-directory "coverage_pages"
                         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -27,14 +27,14 @@
   COMMAND LibIME::prediction "${OPENGRAM_LM_OUTPUT}" "${OPENGRAM_LM_SRC}" "${OPENGRAM_LM_PREDICT_OUTPUT}")
 add_custom_target(opengram-lm-predict ALL DEPENDS "${OPENGRAM_LM_PREDICT_OUTPUT}")
 
-install(FILES "${OPENGRAM_LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
-install(FILES "${OPENGRAM_LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
+install(FILES "${OPENGRAM_LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
+install(FILES "${OPENGRAM_LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 
-set(OPENGRAM_DICT_TAR "dict.utf8-20200715.tar.xz")
+set(OPENGRAM_DICT_TAR "dict.utf8-20210203.tar.xz")
 set(OPENGRAM_DICT_URL "https://download.fcitx-im.org/data/${OPENGRAM_DICT_TAR}")
 
 fcitx5_download(opengram-dict-download ${OPENGRAM_DICT_URL} ${OPENGRAM_DICT_TAR}
-                23c36cd4df6de17f66bf2dfc453ec6c773641a479b6020c9e787552489c9c7d2)
+                2d6b4dca8340ce8525a871943ef0e3eb81f3eda85a92857116cae55fb38d6ec4)
 fcitx5_extract(opengram-dict-extract ${OPENGRAM_DICT_TAR} DEPENDS opengram-dict-download
                OUTPUT dict.utf8)
 set(OPENGRAM_DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict.converted")
@@ -48,7 +48,7 @@
   DEPENDS "${OPENGRAM_DICT_SRC}" LibIME::pinyindict
   COMMAND LibIME::pinyindict "${OPENGRAM_DICT_SRC}" "${OPENGRAM_DICT_OUTPUT}")
 add_custom_target(opengram-dict ALL DEPENDS "${OPENGRAM_DICT_OUTPUT}")
-install(FILES "${OPENGRAM_DICT_OUTPUT}" DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
+install(FILES "${OPENGRAM_DICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")
 
 set(TABLE_DICT_URL "https://download.fcitx-im.org/data/table.tar.gz")
 set(TABLE_DICT_TAR "table.tar.gz")
@@ -69,4 +69,4 @@
 endforeach()
 
 add_custom_target(table-dict ALL DEPENDS ${TABLE_DICT_FILES})
-install(FILES ${TABLE_DICT_FILES} DESTINATION "${CMAKE_INSTALL_DATADIR}/libime")
+install(FILES ${TABLE_DICT_FILES} DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")

=== src/libime/pinyin/CMakeLists.txt ===
--- 
+++ 
@@ -23,12 +23,15 @@
     shuangpinprofile.cpp
     )
 
+ecm_setup_version(PROJECT
+                  VARIABLE_PREFIX IMEPinyin
+                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake")
+set(IMEPinyin_SOVERSION 0)
+
 add_library(IMEPinyin SHARED ${LIBIME_PINYIN_SRCS})
-set_target_properties(IMEPinyin
-                      PROPERTIES VERSION 0.1
-                      SOVERSION 0
-                      COMPILE_FLAGS "-fvisibility=hidden"
-                      LINK_FLAGS "-Wl,--no-undefined"
+set_target_properties(IMEPinyin PROPERTIES
+                      VERSION ${IMEPinyin_VERSION}
+                      SOVERSION ${IMEPinyin_SOVERSION}
                       EXPORT_NAME Pinyin
 )
 target_include_directories(IMEPinyin PUBLIC
@@ -42,10 +45,6 @@
 install(FILES ${LIBIME_PINYIN_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/pinyin")
 
 add_library(LibIME::Pinyin ALIAS IMEPinyin)
-
-ecm_setup_version(PROJECT
-                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake"
-                  SOVERSION 0)
 
 configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMEPinyinConfig.cmake.in"
                               "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"

=== debian/changelog ===
libime (1.0.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 19 Feb 2021 15:14:03 +0800

libime (1.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Update Standards-Version to 4.5.1 (no changes)
  * Add libboost-filesystem-dev to Build-Depends

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 16 Jan 2021 01:25:54 +0800

libime (1.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Fix uscan watch file syntax
  * Refresh patches

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 05 Dec 2020 18:21:19 +0800

libime (1.0.1-3) unstable; urgency=medium

  * Team upload.
  * libime-data-language-model should Breaks+Replaces libimecore0
    Closes: #974044

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 09 Nov 2020 22:36:57 +0800

libime (1.0.1-2) unstable; urgency=medium

  * Team upload.
  * Add libime-data-language-model package

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 07 Nov 2020 22:26:34 +0800

libime (1.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Bump libfcitx5utils-dev to 5.0.1
  * Fix library install patch for new version

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 07 Nov 2020 00:48:37 +0800

libime (0.0~git20201029.22106dc-3) unstable; urgency=medium

  * Team upload.
  * Disable testtrie on mipsx again, still failing in new version.

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 01 Nov 2020 12:57:04 +0800

libime (0.0~git20201029.22106dc-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * Use MUT for data and kenlm source.
  * Do not disable testtrie on mips* and hppa. The problem
    should be fixed with refreshed kenlm code.
  * Bump libfcitx5utils-dev to 0.0~git20201030

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 31 Oct 2020 22:51:05 +0800

=== debian/control ===
--- 
+++ 
@@ -9,11 +9,12 @@
  debhelper-compat (= 13),
  extra-cmake-modules,
  libboost-dev (>= 1.61),
+ libboost-filesystem-dev (>= 1.61),
  libboost-iostreams-dev (>= 1.61),
  libdouble-conversion-dev (>= 3.1.5-5~),
- libfcitx5utils-dev (>= 0.0~git20200626),
+ libfcitx5utils-dev (>= 5.0.1),
  python3:any,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/fcitx/libime
 Vcs-Git: https://salsa.debian.org/input-method-team/libime.git
@@ -39,12 +40,30 @@
 Multi-Arch: foreign
 Section: utils
 Depends:
+ libime-data-language-model (<< ${source:Version}.1~),
+ libime-data-language-model (>= ${source:Version}),
  ${misc:Depends},
 Description: Generic Input Method Implementation library (data files)
  Libime is a generic input method implementation library. It is mainly
  used by fcitx5, the next generation of fcitx input method framework.
  .
  This package provides architecture-independent data files.
+
+Package: libime-data-language-model
+Architecture: any
+Multi-Arch: same
+Section: utils
+Depends:
+ ${misc:Depends},
+Breaks:
+ libimecore0 (<< 1.0.1-2),
+Replaces:
+ libimecore0 (<< 1.0.1-2),
+Description: Generic Input Method Implementation library (language model)
+ Libime is a generic input method implementation library. It is mainly
+ used by fcitx5, the next generation of fcitx input method framework.
+ .
+ This package provides architecture-dependent language models.
 
 Package: libimecore-dev
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

ifneq (,$(filter $(DEB_HOST_ARCH), mips64el mipsel))
override_dh_auto_test:
	dh_auto_test -- ARGS+='--exclude-regex \(testtrie\)'
endif

=== debian/watch ===
version=4

opts="mode=git, pgpmode=none" \
 https://github.com/fcitx/libime \
  refs/tags/@ANY_VERSION@ debian
opts="component=kenlm, filenamemangle=s/.+\/(\w+)\.zip/kenlm-\$1.zip/" \
 https://github.com/kpu/kenlm/tree/01c49fe86714276f77be9278d00906fc994256c1 \
 /kpu/kenlm/archive/(.*)\.zip ignore
opts="component=lmsc" \
 https://download.fcitx-im.org/data/ \
 lm_sc.3gm.arpa-(\d+).tar.bz2 ignore
opts="component=dict" \
 https://download.fcitx-im.org/data/ \
 dict.utf8-(\d+).tar.xz ignore
opts="component=table" \
 https://download.fcitx-im.org/data/ \
 (table).tar.gz ignore

## libime 1.0.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.0.4)
+project(libime VERSION 1.0.11)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LIBIME_SINGLE_FILE_TEST
    testtable
    testpinyindata
    testpinyinencoder
    testinputbuffer
    testhistorybigram
    testshuangpinprofile
    testtrie
    testautophrasedict
    testdecoder
    testpinyincontext
    testpinyindictionary
    testprediction
    testtableime_unit
    )

foreach(TESTCASE ${LIBIME_SINGLE_FILE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} LibIME::Core LibIME::Pinyin LibIME::Table )
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

add_dependencies(testdecoder opengram-dict opengram-lm)

add_executable(triebench triebench.cpp)
target_link_libraries(triebench LibIME::Core)

add_executable(testmodel testmodel.cpp)
target_link_libraries(testmodel LibIME::Core)

add_executable(testpinyinime testpinyinime.cpp)
target_link_libraries(testpinyinime LibIME::Pinyin)

add_executable(testtableime testtableime.cpp)
target_link_libraries(testtableime LibIME::Table)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -23,3 +23,13 @@
 target_link_libraries(libime_tabledict LibIME::Table)
 install(TARGETS libime_tabledict DESTINATION ${CMAKE_INSTALL_BINDIR})
 add_executable(LibIME::tabledict ALIAS libime_tabledict)
+
+add_executable(libime_migrate_fcitx4_table libime_migrate_fcitx4_table.cpp)
+target_link_libraries(libime_migrate_fcitx4_table LibIME::Table Boost::iostreams Boost::filesystem)
+install(TARGETS libime_migrate_fcitx4_table DESTINATION ${CMAKE_INSTALL_BINDIR})
+add_executable(LibIME::migrate_fcitx4_table ALIAS libime_migrate_fcitx4_table)
+
+add_executable(libime_migrate_fcitx4_pinyin libime_migrate_fcitx4_pinyin.cpp)
+target_link_libraries(libime_migrate_fcitx4_pinyin LibIME::Pinyin Boost::iostreams Boost::filesystem)
+install(TARGETS libime_migrate_fcitx4_pinyin DESTINATION ${CMAKE_INSTALL_BINDIR})
+add_executable(LibIME::migrate_fcitx4_pinyin ALIAS libime_migrate_fcitx4_pinyin)

=== src/libime/core/CMakeLists.txt ===
--- 
+++ 
@@ -48,12 +48,16 @@
     triedictionary.cpp
     )
 
+ecm_setup_version(PROJECT
+                  VARIABLE_PREFIX IMECore
+                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake")
+# the cmake if will
+set(IMECore_SOVERSION 0)
+
 add_library(IMECore SHARED ${LIBIME_SRCS})
 set_target_properties(IMECore
-                      PROPERTIES VERSION 0.1
-                      SOVERSION 0
-                      COMPILE_FLAGS "-fvisibility=hidden"
-                      LINK_FLAGS "-Wl,--no-undefined"
+                      PROPERTIES VERSION ${IMECore_VERSION}
+                      SOVERSION ${IMECore_SOVERSION}
                       EXPORT_NAME Core
 )
 target_include_directories(IMECore PUBLIC
@@ -68,10 +72,6 @@
 
 add_library(LibIME::Core ALIAS IMECore)
 
-ecm_setup_version(PROJECT
-                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake"
-                  SOVERSION 0)
-
 configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMECoreConfig.cmake.in"
                               "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
                               INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"

=== src/libime/table/CMakeLists.txt ===
--- 
+++ 
@@ -17,29 +17,29 @@
     log.cpp
     )
 
+ecm_setup_version(PROJECT
+                  VARIABLE_PREFIX IMETable
+                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake")
+set(IMETable_SOVERSION 0)
+
 add_library(IMETable SHARED ${LIBIME_TABLE_SRCS})
 set_target_properties(IMETable
-                      PROPERTIES VERSION 0.1
-                      SOVERSION 0
-                      COMPILE_FLAGS "-fvisibility=hidden"
-                      LINK_FLAGS "-Wl,--no-undefined"
+                      PROPERTIES VERSION ${IMETable_VERSION}
+                      SOVERSION ${IMETable_SOVERSION}
                       EXPORT_NAME Table
 )
+
 target_include_directories(IMETable PUBLIC
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
     $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)
 
-target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)
+target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core PRIVATE Boost::regex)
 
 install(TARGETS IMETable EXPORT LibIMETableTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
 install(FILES ${LIBIME_TABLE_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/table")
 
 add_library(LibIME::Table ALIAS IMETable)
-
-ecm_setup_version(PROJECT
-                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake"
-                  SOVERSION 0)
 
 configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMETableConfig.cmake.in"
                               "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"

=== debian/changelog ===
libime (1.0.11-1build1) jammy; urgency=medium

  * No-change rebuild against libboost-regex1.74.0-icu70.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Feb 2022 16:00:42 +0100

libime (1.0.11-1) unstable; urgency=medium

  * New upstream release 1.0.11.

 -- Boyuan Yang <byang@debian.org>  Fri, 07 Jan 2022 17:13:26 -0500

libime (1.0.10-1) unstable; urgency=medium

  * New upstream release 1.0.10.
  * debian/control: Require fcitx5 (>= 5.0.10).

 -- Boyuan Yang <byang@debian.org>  Tue, 14 Dec 2021 13:54:38 -0500

libime (1.0.9-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Refresh patches.
  * debian/rules: Dynamically generate src/libime/core/kenlm symlink
    immediately before configure, instead of including it in patch.
    This circumvents some corner cases with MUT + git-buildpackage
    combination.

 -- Boyuan Yang <byang@debian.org>  Tue, 23 Nov 2021 15:24:18 -0500

libime (1.0.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream release

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 01 Oct 2021 02:26:08 +0800

libime (1.0.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Update Standards-Version to 4.6.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 25 Aug 2021 02:29:52 +0800

=== debian/control ===
--- 
+++ 
@@ -12,9 +12,9 @@
  libboost-filesystem-dev (>= 1.61),
  libboost-iostreams-dev (>= 1.61),
  libdouble-conversion-dev (>= 3.1.5-5~),
- libfcitx5utils-dev (>= 5.0.1),
+ libfcitx5utils-dev (>= 5.0.11),
  python3:any,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/fcitx/libime
 Vcs-Git: https://salsa.debian.org/input-method-team/libime.git

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,11 @@
 %:
 	dh $@
 
+# Create kenlm symlink immediately before configure
+execute_before_dh_auto_configure:
+	rmdir src/libime/core/kenlm
+	ln -sf $(CURDIR)/kenlm $(CURDIR)/src/libime/core/kenlm
+
 ifneq (,$(filter $(DEB_HOST_ARCH), mips64el mipsel))
 override_dh_auto_test:
 	dh_auto_test -- ARGS+='--exclude-regex \(testtrie\)'

=== debian/watch ===
version=4

opts="mode=git, pgpmode=none" \
 https://github.com/fcitx/libime \
  refs/tags/@ANY_VERSION@ debian
opts="component=kenlm, downloadurlmangle=s|commit\/(\w+)|archive/\$1.zip|, filenamemangle=s|.+/(\w+)|kenlm-\$1.zip|" \
 https://github.com/kpu/kenlm/commit/01c49fe86714276f77be9278d00906fc994256c1 \
 /kpu/kenlm/commit/(01c49fe86714276f77be9278d00906fc994256c1) ignore
opts="component=lmsc" \
 https://download.fcitx-im.org/data/ \
 lm_sc.3gm.arpa-(\d+).tar.bz2 ignore
opts="component=dict,pgpmode=none" \
 https://download.fcitx-im.org/data/ \
 dict.utf8-(\d+).tar.xz ignore
opts="component=table" \
 https://download.fcitx-im.org/data/ \
 (table).tar.gz ignore

## libime 1.0.11.1

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,11 @@
 install(FILES "${OPENGRAM_LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 install(FILES "${OPENGRAM_LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 
-set(OPENGRAM_DICT_TAR "dict.utf8-20210203.tar.xz")
+set(OPENGRAM_DICT_TAR "dict.utf8-20211021.tar.xz")
 set(OPENGRAM_DICT_URL "https://download.fcitx-im.org/data/${OPENGRAM_DICT_TAR}")
 
 fcitx5_download(opengram-dict-download ${OPENGRAM_DICT_URL} ${OPENGRAM_DICT_TAR}
-                2d6b4dca8340ce8525a871943ef0e3eb81f3eda85a92857116cae55fb38d6ec4)
+               300597e6f7f79f788480fd665de8a07bfe90227048b5a7e39f40f43a62a981df)
 fcitx5_extract(opengram-dict-extract ${OPENGRAM_DICT_TAR} DEPENDS opengram-dict-download
                OUTPUT dict.utf8)
 set(OPENGRAM_DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict.converted")

=== src/libime/core/kenlm/util/double-conversion/CMakeLists.txt ===
# This CMake file was created by Lane Schwartz <dowobeha@gmail.com>

# Explicitly list the source files for this subdirectory
#
# If you add any source files to this subdirectory
#    that should be included in the kenlm library,
#        (this excludes any unit test files)
#    you should add them to the following list:
#
# In order to allow CMake files in the parent directory
#    to see this variable definition, we set PARENT_SCOPE.
#
# In order to set correct paths to these files
#    when this variable is referenced by CMake files in the parent directory,
#    we prefix all files with ${CMAKE_CURRENT_SOURCE_DIR}.
#
set(KENLM_UTIL_DOUBLECONVERSION_SOURCE
		${CMAKE_CURRENT_SOURCE_DIR}/bignum-dtoa.cc
		${CMAKE_CURRENT_SOURCE_DIR}/bignum.cc
		${CMAKE_CURRENT_SOURCE_DIR}/cached-powers.cc
		${CMAKE_CURRENT_SOURCE_DIR}/diy-fp.cc
		${CMAKE_CURRENT_SOURCE_DIR}/double-conversion.cc
		${CMAKE_CURRENT_SOURCE_DIR}/fast-dtoa.cc
		${CMAKE_CURRENT_SOURCE_DIR}/fixed-dtoa.cc
		${CMAKE_CURRENT_SOURCE_DIR}/strtod.cc
	PARENT_SCOPE)

=== debian/changelog ===
libime (1.0.11.1-1) unstable; urgency=medium

  * update

 -- Debian Input Method Team <debian-input-method@lists.debian.org>  Mon, 07 Feb 2022 21:30:23 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libboost-dev (>= 1.61),
  libboost-filesystem-dev (>= 1.61),
  libboost-iostreams-dev (>= 1.61),
- libdouble-conversion-dev (>= 3.1.5-5~),
+ libdouble-conversion-dev (>= 3.1.0-3~),
  libfcitx5utils-dev (>= 5.0.11),
  python3:any,
 Standards-Version: 4.6.0

=== debian/watch ===
version=4

opts="mode=git, pgpmode=none" \
 https://github.com/fcitx/libime \
  refs/tags/@ANY_VERSION@ debian
opts="component=lmsc" \
 https://download.fcitx-im.org/data/ \
 lm_sc.3gm.arpa-(\d+).tar.bz2 ignore
opts="component=dict,pgpmode=none" \
 https://download.fcitx-im.org/data/ \
 dict.utf8-(\d+).tar.xz ignore
opts="component=table" \
 https://download.fcitx-im.org/data/ \
 (table).tar.gz ignore
